'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _resizeObserverPolyfill = require('resize-observer-polyfill');

var _resizeObserverPolyfill2 = _interopRequireDefault(_resizeObserverPolyfill);

var _propTypes = require('./propTypes');

var customTypes = _interopRequireWildcard(_propTypes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AutoAdjust = function (_React$Component) {
  _inherits(AutoAdjust, _React$Component);

  function AutoAdjust(props) {
    _classCallCheck(this, AutoAdjust);

    var _this = _possibleConstructorReturn(this, (AutoAdjust.__proto__ || Object.getPrototypeOf(AutoAdjust)).call(this, props));

    _this.state = {
      height: 0,
      width: 0
    };
    _this._autoAdjustDiv = null;
    _this._getRef = _this._getRef.bind(_this);
    _this._updateDimensions = _this._updateDimensions.bind(_this);
    _this._resizeObserver = new _resizeObserverPolyfill2.default(_this._updateDimensions);
    return _this;
  }

  _createClass(AutoAdjust, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      window.addEventListener('resize', this._updateDimensions);
      this._resizeObserver.observe(this._autoAdjustDiv);
      this._updateDimensions();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this._updateDimensions();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      window.removeEventListener('resize', this._updateDimensions);
      this._resizeObserver.unobserve(this._autoAdjustDiv);
      this.setState({ height: 0, width: 0 });
      this.autoAdjustDiv = null;
    }
  }, {
    key: '_getRef',
    value: function _getRef(ref) {
      this._autoAdjustDiv = ref;
    }
  }, {
    key: '_updateDimensions',
    value: function _updateDimensions() {
      var _autoAdjustDiv = this._autoAdjustDiv;
      var _autoAdjustDiv2 = this._autoAdjustDiv;
      var height = _autoAdjustDiv2.clientHeight;
      var width = _autoAdjustDiv2.clientWidth;
      var _state = this.state;
      var prevHeight = _state.height;
      var prevWidth = _state.width;


      if (!_autoAdjustDiv || prevHeight === height && prevWidth === width) {
        return;
      }

      this.setState({ height: height, width: width });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var Component = _props.component;
      var heightAdjust = _props.heightAdjust;
      var widthAdjust = _props.widthAdjust;

      var props = _objectWithoutProperties(_props, ['component', 'heightAdjust', 'widthAdjust']);

      var _state2 = this.state;
      var height = _state2.height;
      var width = _state2.width;
      var _autoAdjustDiv = this._autoAdjustDiv;


      var style = {
        height: heightAdjust ? 'calc(100% - ' + heightAdjust + 'px)' : '100%',
        width: widthAdjust ? 'calc(100% - ' + widthAdjust + 'px)' : '100%'
      };

      var child = _autoAdjustDiv ? _react2.default.createElement(Component, _extends({ height: height }, props, { width: width })) : null;

      return _react2.default.createElement(
        'div',
        { className: 'autoadjust', ref: this._getRef, style: style },
        child
      );
    }
  }]);

  return AutoAdjust;
}(_react2.default.Component);

exports.default = AutoAdjust;


AutoAdjust.propTypes = {
  component: customTypes.renderableComponent,
  heightAdjust: _react.PropTypes.number,
  widthAdjust: _react.PropTypes.number
};