'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _constants = require('./constants');

var constants = _interopRequireWildcard(_constants);

var _HorizontalWrapper = require('./HorizontalWrapper');

var _HorizontalWrapper2 = _interopRequireDefault(_HorizontalWrapper);

var _propTypes = require('./propTypes');

var customTypes = _interopRequireWildcard(_propTypes);

var _utils = require('./utils');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Row = function (_React$Component) {
  _inherits(Row, _React$Component);

  function Row(props) {
    _classCallCheck(this, Row);

    var _this = _possibleConstructorReturn(this, (Row.__proto__ || Object.getPrototypeOf(Row)).call(this, props));

    _this._getRenderableHandle = _this._getRenderableHandle.bind(_this);
    return _this;
  }

  _createClass(Row, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return !_lodash2.default.isEqual(nextProps, this.props) || !_lodash2.default.isEqual(nextState, this.state);
    }
  }, {
    key: '_getRenderableGutter',
    value: function _getRenderableGutter(side, index) {
      var _ref = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

      var thisGutterClassName = _ref.className;
      var ContentComponent = _ref.contentComponent;
      var _ref$props = _ref.props;
      var props = _ref$props === undefined ? {} : _ref$props;
      var width = arguments[3];
      var gutterClassName = arguments[4];

      var gutterStyle = (0, _utils.getWidthStyle)(width);
      var className = (0, _classnames2.default)('rickscroll__gutter', gutterClassName, thisGutterClassName);
      return ContentComponent && gutterStyle ? _react2.default.createElement(
        'span',
        { className: className, style: gutterStyle },
        _react2.default.createElement(ContentComponent, _extends({ key: 'gutter-' + side }, props))
      ) : undefined;
    }
  }, {
    key: '_getRenderableHandle',
    value: function _getRenderableHandle(side) {
      var _ref2 = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

      var contentComponent = _ref2.contentComponent;
      var thisHandleClassName = _ref2.handleClassName;
      var width = arguments[2];
      var handleClassName = arguments[3];
      var _props = this.props;
      var _props$guttersConfig = _props.guttersConfig;
      _props$guttersConfig = _props$guttersConfig === undefined ? {} : _props$guttersConfig;
      var _props$guttersConfig$ = _props$guttersConfig[side];
      _props$guttersConfig$ = _props$guttersConfig$ === undefined ? {} : _props$guttersConfig$;
      var onResize = _props$guttersConfig$.onResize;
      var _props$onStartResize = _props.onStartResize;
      var onStartResize = _props$onStartResize === undefined ? function () {
        return function () {};
      } : _props$onStartResize;

      var handleStyle = (0, _utils.getWidthStyle)(width);
      var className = (0, _classnames2.default)(handleClassName, thisHandleClassName, 'rickscroll__handle', { 'rickscroll__handle--grabbable': !!onResize }, 'rickscroll__handle--' + side);
      return contentComponent && handleStyle ? _react2.default.createElement('span', {
        className: className,
        key: 'handle-' + side,
        onMouseDown: onStartResize(side),
        style: handleStyle
      }) : undefined;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props;
      var thisRowClassName = _props2.className;
      var ContentComponent = _props2.contentComponent;
      var thisContentClassName = _props2.contentClassName;
      var _props2$dynamicColumn = _props2.dynamicColumn;
      var dynamicColumn = _props2$dynamicColumn === undefined ? constants.columns.MIDDLE : _props2$dynamicColumn;
      var guttersConfig = _props2.guttersConfig;
      var _props2$guttersConfig = _props2.guttersConfig;
      _props2$guttersConfig = _props2$guttersConfig === undefined ? {} : _props2$guttersConfig;
      var leftCanExist = _props2$guttersConfig.left;
      var _props2$guttersConfig2 = _props2$guttersConfig.left;
      _props2$guttersConfig2 = _props2$guttersConfig2 === undefined ? {} : _props2$guttersConfig2;
      var leftGutterClassName = _props2$guttersConfig2.className;
      var leftHandleClassName = _props2$guttersConfig2.handleClassName;
      var leftHandleWidth = _props2$guttersConfig2.handleWidth;
      var leftHandlePosition = _props2$guttersConfig2.position;
      var rightCanExist = _props2$guttersConfig.right;
      var _props2$guttersConfig3 = _props2$guttersConfig.right;
      _props2$guttersConfig3 = _props2$guttersConfig3 === undefined ? {} : _props2$guttersConfig3;
      var rightGutterClassName = _props2$guttersConfig3.className;
      var rightHandleClassName = _props2$guttersConfig3.handleClassName;
      var _props2$guttersConfig4 = _props2$guttersConfig3.handleWidth;
      var rightHandleWidth = _props2$guttersConfig4 === undefined ? constants.RIGHT_HANDLE_WIDTH : _props2$guttersConfig4;
      var rightHandlePosition = _props2$guttersConfig3.position;
      var _props2$gutters = _props2.gutters;
      var gutters = _props2$gutters === undefined ? {} : _props2$gutters;
      var horizontalTransform = _props2.horizontalTransform;
      var index = _props2.index;
      var isHeader = _props2.isHeader;
      var onClick = _props2.onClick;
      var passthroughOffsets = _props2.passthroughOffsets;
      var rowHeight = _props2.rowHeight;
      var _props2$rowProps = _props2.rowProps;
      var rowProps = _props2$rowProps === undefined ? {} : _props2$rowProps;
      var width = _props2.width;

      var rowStyle = {
        height: rowHeight + 'px',
        width: width + 'px'
      };

      var _getGutterWidths = (0, _utils.getGutterWidths)({
        dynamicColumn: guttersConfig ? dynamicColumn : constants.columns.MIDDLE,
        leftHandlePosition: leftHandlePosition,
        leftHandleWidth: leftHandleWidth,
        rightHandlePosition: rightHandlePosition,
        rightHandleWidth: rightHandleWidth,
        width: width
      });

      var leftGutterWidth = _getGutterWidths.leftGutterWidth;
      var rightGutterWidth = _getGutterWidths.rightGutterWidth;


      var leftComponent = leftCanExist ? this._getRenderableGutter(constants.columns.LEFT, index, gutters.left, leftGutterWidth, leftGutterClassName) : null;
      var leftHandleComponent = leftCanExist ? this._getRenderableHandle(constants.columns.LEFT, gutters.left, leftHandleWidth, leftHandleClassName) : null;
      var rightComponent = rightCanExist ? this._getRenderableGutter(constants.columns.RIGHT, index, gutters.right, rightGutterWidth, rightGutterClassName) : null;
      var rightHandleComponent = rightCanExist ? this._getRenderableHandle(constants.columns.RIGHT, gutters.right, rightHandleWidth, rightHandleClassName) : null;

      var contentComponent = void 0;
      if (horizontalTransform !== undefined && !isHeader) {
        contentComponent = passthroughOffsets ? _react2.default.createElement(ContentComponent, _extends({ key: 'content', offset: horizontalTransform || 0 }, rowProps)) : _react2.default.createElement(
          _HorizontalWrapper2.default,
          { key: 'content', offset: horizontalTransform || 0 },
          _react2.default.createElement(ContentComponent, rowProps)
        );
      } else {
        contentComponent = _react2.default.createElement(ContentComponent, _extends({ key: 'content' }, rowProps));
      }

      var rowClassName = (0, _classnames2.default)('rickscroll__row', thisRowClassName);
      var contentClassName = (0, _classnames2.default)('rickscroll__content', thisContentClassName);

      return _react2.default.createElement(
        'div',
        { className: rowClassName, onClick: onClick, style: rowStyle },
        leftComponent,
        leftHandleComponent,
        _react2.default.createElement(
          'span',
          { className: contentClassName, key: 'content-wrapper' },
          contentComponent
        ),
        rightHandleComponent,
        rightComponent
      );
    }
  }]);

  return Row;
}(_react2.default.Component);

exports.default = Row;


Row.propTypes = {
  className: _react.PropTypes.string,
  contentClassName: _react.PropTypes.string,
  contentComponent: customTypes.renderableComponent,
  dynamicColumn: customTypes.column,
  gutters: customTypes.gutters,
  guttersConfig: customTypes.guttersConfig,
  horizontalTransform: _react.PropTypes.number,
  index: _react.PropTypes.number.isRequired,
  isHeader: _react.PropTypes.bool,
  onClick: _react.PropTypes.func,
  onStartResize: _react.PropTypes.func,
  passthroughOffsets: _react.PropTypes.bool,
  rowHeight: _react.PropTypes.number.isRequired,
  rowProps: _react.PropTypes.object,
  width: _react.PropTypes.number.isRequired
};