'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _animationTimer = require('animation-timer');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _functionalEasing = require('functional-easing');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _constants = require('./constants');

var constants = _interopRequireWildcard(_constants);

var _propTypes = require('./propTypes');

var customTypes = _interopRequireWildcard(_propTypes);

var _models = require('./models');

var _Row = require('./Row');

var _Row2 = _interopRequireDefault(_Row);

var _utils = require('./utils');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var easer = new _functionalEasing.Easer().using('out-cubic');

var Scrollable = function (_React$Component) {
  _inherits(Scrollable, _React$Component);

  function Scrollable(props) {
    _classCallCheck(this, Scrollable);

    var _this = _possibleConstructorReturn(this, (Scrollable.__proto__ || Object.getPrototypeOf(Scrollable)).call(this, props));

    ['_applyScrollChange', '_getContentWidth', '_getDimensions', '_getThrottledAnimationFrameFn', '_getWeightedWidth', '_onHorizontalScroll', '_onResize', '_onMouseWheel', '_onVerticalScroll', '_renderContents', '_renderCorner', '_renderHorizontalScrollbar', '_renderHeader', '_renderVerticalScrollbar', '_shouldRenderScrollbars', '_startResize', '_stopResize', 'scrollToHeader', 'toggleSection'].forEach(function (method) {
      _this[method] = _this[method].bind(_this);
    });
    _this._onThrottledMouseWheel = (0, _utils.triggerAnimationFrameCreator)(_this._applyScrollChange);

    var _props$headerType = props.headerType;
    var headerType = _props$headerType === undefined ? constants.headerType.DEFAULT : _props$headerType;
    var height = props.height;
    var list = props.list;
    var lists = props.lists;
    var width = props.width;

    var stackingHeaders = headerType === constants.headerType.STACKING;
    var listContainer = list || lists;

    var _buildRowConfig = (0, _utils.buildRowConfig)(listContainer, stackingHeaders);

    var avgRowHeight = _buildRowConfig.avgRowHeight;
    var collapsedSections = _buildRowConfig.collapsedSections;
    var contentHeight = _buildRowConfig.contentHeight;
    var headers = _buildRowConfig.headers;
    var partitions = _buildRowConfig.partitions;
    var rows = _buildRowConfig.rows;

    var _this$_getDimensions = _this._getDimensions(avgRowHeight, contentHeight, height, width);

    var displayBuffer = _this$_getDimensions.displayBuffer;
    var shouldRender = _this$_getDimensions.shouldRender;


    _this.state = {
      animation: null,
      avgRowHeight: avgRowHeight,
      collapsedSections: collapsedSections,
      contentHeight: contentHeight,
      displayBuffer: displayBuffer,
      headers: headers,
      horizontalTransform: 0,
      partitions: partitions,
      resize: {
        basePosition: 0,
        currentPosition: 0,
        performing: false,
        side: '',
        startingPosition: 0
      },
      rows: rows,
      scrollingToPosition: new _models.Point(0, 0),
      shouldRender: shouldRender,
      topPartitionIndex: 0,
      verticalTransform: 0
    };
    return _this;
  }

  _createClass(Scrollable, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(_ref) {
      var guttersConfig = _ref.guttersConfig;
      var _ref$headerType = _ref.headerType;
      var headerType = _ref$headerType === undefined ? constants.headerType.DEFAULT : _ref$headerType;
      var height = _ref.height;
      var horizontalScrollConfig = _ref.horizontalScrollConfig;
      var nextList = _ref.list;
      var nextLists = _ref.lists;
      var verticalScrollConfig = _ref.verticalScrollConfig;
      var width = _ref.width;
      var _props = this.props;
      var prevGuttersConfig = _props.guttersConfig;
      var prevHeight = _props.height;
      var prevHorizontalScrollConfig = _props.horizontalScrollConfig;
      var prevList = _props.list;
      var prevLists = _props.lists;
      var prevVerticalScrollConfig = _props.verticalScrollConfig;
      var prevWidth = _props.width;
      var _state = this.state;
      var prevAvgRowHeight = _state.avgRowHeight;
      var oldCollapsedSections = _state.collapsedSections;
      var prevContentHeight = _state.contentHeight;


      var stackingHeaders = headerType === constants.headerType.STACKING;
      var prevListContainer = prevList || prevLists;
      var nextListContainer = nextList || nextLists;

      if (prevListContainer !== nextListContainer || !_lodash2.default.isEqual(prevListContainer, nextListContainer)) {
        var _buildRowConfig2 = (0, _utils.buildRowConfig)(nextListContainer, stackingHeaders, oldCollapsedSections);

        var avgRowHeight = _buildRowConfig2.avgRowHeight;
        var collapsedSections = _buildRowConfig2.collapsedSections;
        var contentHeight = _buildRowConfig2.contentHeight;
        var headers = _buildRowConfig2.headers;
        var partitions = _buildRowConfig2.partitions;
        var rows = _buildRowConfig2.rows;

        this.setState(_extends({
          avgRowHeight: avgRowHeight,
          collapsedSections: collapsedSections,
          contentHeight: contentHeight,
          headers: headers,
          partitions: partitions,
          rows: rows
        }, this._getDimensions(avgRowHeight, contentHeight, height, width)));
      } else if (height !== prevHeight || width !== prevWidth || !_lodash2.default.isEqual(prevGuttersConfig, guttersConfig) || !_lodash2.default.isEqual(prevHorizontalScrollConfig, horizontalScrollConfig) || !_lodash2.default.isEqual(prevVerticalScrollConfig, verticalScrollConfig)) {
        this.setState(this._getDimensions(prevAvgRowHeight, prevContentHeight, height, width));
      }
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return !_lodash2.default.isEqual(this.props, nextProps) || !_lodash2.default.isEqual(this.state, nextState);
    }

    // private

  }, {
    key: '_applyScrollChange',
    value: function _applyScrollChange(_ref2) {
      var deltaX = _ref2.deltaX;
      var deltaY = _ref2.deltaY;
      var horizontalScrollConfig = this.props.horizontalScrollConfig;
      var _state2 = this.state;
      var contentHeight = _state2.contentHeight;
      var partitions = _state2.partitions;
      var shouldRender = _state2.shouldRender;
      var _horizontalScrollbar = this._horizontalScrollbar;
      var _verticalScrollbar = this._verticalScrollbar;

      var withHorizontalScrolling = !!horizontalScrollConfig && shouldRender.horizontalScrollbar;

      var scrollChanges = {};

      // vertical
      if (shouldRender.verticalScrollbar) {
        var maxHeight = (0, _utils.getMaxHeight)(contentHeight, _verticalScrollbar.offsetHeight);
        var verticalTransform = this.state.verticalTransform + deltaY;
        _lodash2.default.assign(scrollChanges, (0, _utils.getVerticalScrollValues)(verticalTransform, maxHeight, partitions));
      }

      // horizontal scrolling
      if (withHorizontalScrolling) {
        scrollChanges.horizontalTransform = _lodash2.default.clamp(this.state.horizontalTransform + deltaX, 0, _horizontalScrollbar.scrollWidth - _horizontalScrollbar.offsetWidth);
      }

      this.setState(scrollChanges, function () {
        if (shouldRender.verticalScrollbar) {
          _verticalScrollbar.scrollTop = scrollChanges.verticalTransform;
        }
        if (withHorizontalScrolling) {
          _horizontalScrollbar.scrollLeft = scrollChanges.horizontalTransform;
        }
      });
    }
  }, {
    key: '_getContentWidth',
    value: function _getContentWidth() {
      var _props2 = this.props;
      var _props2$dynamicColumn = _props2.dynamicColumn;
      var dynamicColumn = _props2$dynamicColumn === undefined ? constants.columns.MIDDLE : _props2$dynamicColumn;
      var guttersConfig = _props2.guttersConfig;
      var _props2$guttersConfig = _props2.guttersConfig;
      _props2$guttersConfig = _props2$guttersConfig === undefined ? {} : _props2$guttersConfig;
      var _props2$guttersConfig2 = _props2$guttersConfig.left;
      _props2$guttersConfig2 = _props2$guttersConfig2 === undefined ? {} : _props2$guttersConfig2;
      var _props2$guttersConfig3 = _props2$guttersConfig2.handleWidth;
      var leftHandleWidth = _props2$guttersConfig3 === undefined ? constants.LEFT_HANDLE_WIDTH : _props2$guttersConfig3;
      var leftGutterPosition = _props2$guttersConfig2.position;
      var _props2$guttersConfig4 = _props2$guttersConfig.right;
      _props2$guttersConfig4 = _props2$guttersConfig4 === undefined ? {} : _props2$guttersConfig4;
      var _props2$guttersConfig5 = _props2$guttersConfig4.handleWidth;
      var rightHandleWidth = _props2$guttersConfig5 === undefined ? constants.RIGHT_HANDLE_WIDTH : _props2$guttersConfig5;
      var rightGutterPosition = _props2$guttersConfig4.position;
      var _props2$horizontalScr = _props2.horizontalScrollConfig;
      _props2$horizontalScr = _props2$horizontalScr === undefined ? {} : _props2$horizontalScr;
      var _props2$horizontalScr2 = _props2$horizontalScr.contentWidth;
      var contentWidth = _props2$horizontalScr2 === undefined ? 0 : _props2$horizontalScr2;
      var width = _props2.width;


      var leftGutterWidth = void 0;
      var rightGutterWidth = void 0;
      switch (guttersConfig ? dynamicColumn : constants.columns.MIDDLE) {
        case constants.columns.LEFT:
          leftGutterWidth = width - leftGutterPosition - leftHandleWidth;
          rightGutterWidth = rightGutterPosition;
          break;
        case constants.columns.RIGHT:
          leftGutterWidth = leftGutterPosition;
          rightGutterWidth = width - rightGutterPosition - rightHandleWidth;
          break;
        default:
          leftGutterWidth = leftGutterPosition;
          rightGutterWidth = rightGutterPosition;
      }

      return _lodash2.default.sum([contentWidth, leftGutterWidth, leftHandleWidth, rightHandleWidth, rightGutterWidth]);
    }
  }, {
    key: '_getDimensions',
    value: function _getDimensions(avgRowHeight, contentHeight, height, width) {
      var _ref3 = this.props.horizontalScrollConfig || {};

      var _ref3$scrollbarHeight = _ref3.scrollbarHeight;
      var scrollbarHeight = _ref3$scrollbarHeight === undefined ? constants.HORIZONTAL_SCROLLBAR_HEIGHT : _ref3$scrollbarHeight;

      var shouldRender = this._shouldRenderScrollbars(contentHeight, height, width);
      var contentsDivHeight = height - (shouldRender.horizontalScrollbar ? scrollbarHeight : 0);
      var numRowsInContents = _lodash2.default.ceil(contentsDivHeight / avgRowHeight);

      var displayBuffer = numRowsInContents + 2 * constants.OFFSET_BUFFER;
      displayBuffer += constants.OFFSET_BUFFER - displayBuffer % constants.OFFSET_BUFFER;

      var newState = {
        displayBuffer: displayBuffer,
        shouldRender: shouldRender
      };

      if (!shouldRender.verticalScrollbar) {
        newState.verticalTransform = 0;
        newState.topPartitionIndex = 0;
        if (this._verticalScrollbar) {
          this._verticalScrollbar.scrollTop = 0;
        }
      }

      if (!shouldRender.horizontalScrollbar) {
        newState.horizontalTransform = 0;
        if (this._horizontalScrollbar) {
          this._horizontalScrollbar.scrollLeft = 0;
        }
      }

      return newState;
    }
  }, {
    key: '_getThrottledAnimationFrameFn',
    value: function _getThrottledAnimationFrameFn(scrollTo) {
      var _this2 = this;

      var _state3 = this.state;
      var horizontalTransform = _state3.horizontalTransform;
      var verticalTransform = _state3.verticalTransform;

      var delta = _lodash2.default.clone(scrollTo).sub(new _models.Point(horizontalTransform, verticalTransform));

      return _lodash2.default.throttle(easer(function (easedElapsedTime) {
        var horizontalScrollConfig = _this2.props.horizontalScrollConfig;
        var _state4 = _this2.state;
        var contentHeight = _state4.contentHeight;
        var partitions = _state4.partitions;
        var latestScrollingToPosition = _state4.scrollingToPosition;
        var shouldRender = _state4.shouldRender;
        var _horizontalScrollbar = _this2._horizontalScrollbar;
        var _verticalScrollbar = _this2._verticalScrollbar;

        if (!_lodash2.default.isEqual(scrollTo, latestScrollingToPosition)) {
          return;
        }

        var withHorizontalScrolling = !!horizontalScrollConfig && shouldRender.horizontalScrollbar;
        var elapsedTime = easedElapsedTime > 0.999 ? 1 : easedElapsedTime;
        var deltaScrolled = new _models.Point(delta.x, delta.y).scale(elapsedTime);
        var newTransform = new _models.Point(horizontalTransform, verticalTransform).add(deltaScrolled);

        var scrollChanges = {};

        // vertical
        if (shouldRender.verticalScrollbar) {
          var maxHeight = (0, _utils.getMaxHeight)(contentHeight, _verticalScrollbar.offsetHeight);
          _lodash2.default.assign(scrollChanges, (0, _utils.getVerticalScrollValues)(newTransform.y, maxHeight, partitions));
        }

        // horizontal scrolling
        if (withHorizontalScrolling) {
          scrollChanges.horizontalTransform = _lodash2.default.clamp(newTransform.x, 0, _horizontalScrollbar.scrollWidth - _horizontalScrollbar.offsetWidth);
        }

        _this2.setState(scrollChanges, function () {
          if (shouldRender.verticalScrollbar) {
            _verticalScrollbar.scrollTop = scrollChanges.verticalTransform;
          }
          if (withHorizontalScrolling) {
            _horizontalScrollbar.scrollLeft = scrollChanges.horizontalTransform;
          }
        });
      }), constants.ANIMATION_FPS_120, { leading: true });
    }
  }, {
    key: '_getWeightedWidth',
    value: function _getWeightedWidth() {
      var _props3 = this.props;
      var _props3$verticalScrol = _props3.verticalScrollConfig;
      _props3$verticalScrol = _props3$verticalScrol === undefined ? {} : _props3$verticalScrol;
      var _props3$verticalScrol2 = _props3$verticalScrol.scrollbarWidth;
      var scrollbarWidth = _props3$verticalScrol2 === undefined ? constants.VERTICAL_SCROLLBAR_WIDTH : _props3$verticalScrol2;
      var width = _props3.width;
      var shouldRender = this.state.shouldRender;


      return width - (shouldRender.verticalScrollbar ? scrollbarWidth : 0);
    }
  }, {
    key: '_onHorizontalScroll',
    value: function _onHorizontalScroll() {
      var _props$horizontalScro = this.props.horizontalScrollConfig;
      _props$horizontalScro = _props$horizontalScro === undefined ? {} : _props$horizontalScro;
      var _props$horizontalScro2 = _props$horizontalScro.onScroll;
      var onScroll = _props$horizontalScro2 === undefined ? function () {} : _props$horizontalScro2;

      var _ref4 = this._horizontalScrollbar || {};

      var _ref4$scrollLeft = _ref4.scrollLeft;
      var scrollLeft = _ref4$scrollLeft === undefined ? 0 : _ref4$scrollLeft;

      this.setState({ horizontalTransform: scrollLeft });
      onScroll(scrollLeft);
    }
  }, {
    key: '_onMouseWheel',
    value: function _onMouseWheel(_ref5) {
      var deltaX = _ref5.deltaX;
      var deltaY = _ref5.deltaY;

      this._onThrottledMouseWheel({ deltaX: deltaX, deltaY: deltaY });
    }

    /**
     * Performs a calculation to determine the size difference between each movement of the mouse cursor. Only occurs when
     * a resize is active. Will call the onResize handler for the gutter that is being resized with the new width of the
     * gutter.
     * @param  {number} clientX the position of the mouse cursor horizontally
     */

  }, {
    key: '_onResize',
    value: function _onResize(_ref6) {
      var clientX = _ref6.clientX;
      var _state$resize = this.state.resize;
      var basePosition = _state$resize.basePosition;
      var performing = _state$resize.performing;
      var side = _state$resize.side;
      var startingPosition = _state$resize.startingPosition;

      var width = this._getWeightedWidth();
      var _props4 = this.props;
      var _props4$dynamicColumn = _props4.dynamicColumn;
      var dynamicColumn = _props4$dynamicColumn === undefined ? constants.columns.MIDDLE : _props4$dynamicColumn;
      var guttersConfig = _props4.guttersConfig;
      var _props4$guttersConfig = _props4.guttersConfig;
      _props4$guttersConfig = _props4$guttersConfig === undefined ? {} : _props4$guttersConfig;
      var left = _props4$guttersConfig.left;
      var _props4$guttersConfig2 = _props4$guttersConfig.left;
      _props4$guttersConfig2 = _props4$guttersConfig2 === undefined ? {} : _props4$guttersConfig2;
      var _props4$guttersConfig3 = _props4$guttersConfig2.handleWidth;
      var leftHandleWidth = _props4$guttersConfig3 === undefined ? constants.LEFT_HANDLE_WIDTH : _props4$guttersConfig3;
      var leftHandlePosition = _props4$guttersConfig2.position;
      var right = _props4$guttersConfig.right;
      var _props4$guttersConfig4 = _props4$guttersConfig.right;
      _props4$guttersConfig4 = _props4$guttersConfig4 === undefined ? {} : _props4$guttersConfig4;
      var _props4$guttersConfig5 = _props4$guttersConfig4.handleWidth;
      var rightHandleWidth = _props4$guttersConfig5 === undefined ? constants.RIGHT_HANDLE_WIDTH : _props4$guttersConfig5;
      var rightHandlePosition = _props4$guttersConfig4.position;
      var _props4$guttersConfig6 = _props4$guttersConfig[side];
      _props4$guttersConfig6 = _props4$guttersConfig6 === undefined ? {} : _props4$guttersConfig6;
      var _props4$guttersConfig7 = _props4$guttersConfig6.minPosition;
      var minPosition = _props4$guttersConfig7 === undefined ? 0 : _props4$guttersConfig7;
      var _props4$guttersConfig8 = _props4$guttersConfig6.maxPosition;
      var maxPosition = _props4$guttersConfig8 === undefined ? width : _props4$guttersConfig8;
      var _props4$guttersConfig9 = _props4$guttersConfig6.onResize;
      var onResize = _props4$guttersConfig9 === undefined ? function () {} : _props4$guttersConfig9;

      if (performing) {
        var deltaPosition = startingPosition - clientX;

        var _getResizeValues = (0, _utils.getResizeValues)({
          dynamicColumn: guttersConfig ? dynamicColumn : constants.columns.MIDDLE,
          leftExists: Boolean(left),
          leftHandlePosition: leftHandlePosition,
          leftHandleWidth: leftHandleWidth,
          rightExists: Boolean(right),
          rightHandlePosition: rightHandlePosition,
          rightHandleWidth: rightHandleWidth,
          side: side,
          width: width
        });

        var max = _getResizeValues.max;
        var min = _getResizeValues.min;
        var mod = _getResizeValues.mod;


        onResize(_lodash2.default.clamp(basePosition + mod * deltaPosition, Math.max(minPosition, min), Math.min(maxPosition, max)));
      }
    }
  }, {
    key: '_onVerticalScroll',
    value: function _onVerticalScroll() {
      var _props$verticalScroll = this.props.verticalScrollConfig;
      _props$verticalScroll = _props$verticalScroll === undefined ? {} : _props$verticalScroll;
      var _props$verticalScroll2 = _props$verticalScroll.onScroll;
      var onScroll = _props$verticalScroll2 === undefined ? function () {} : _props$verticalScroll2;
      var _state5 = this.state;
      var contentHeight = _state5.contentHeight;
      var partitions = _state5.partitions;
      var _verticalScrollbar = this._verticalScrollbar;
      var _verticalScrollbar2 = this._verticalScrollbar;
      _verticalScrollbar2 = _verticalScrollbar2 === undefined ? {} : _verticalScrollbar2;
      var offsetHeight = _verticalScrollbar2.offsetHeight;
      var scrollTop = _verticalScrollbar2.scrollTop;


      if (!_verticalScrollbar) {
        return;
      }

      var maxHeight = (0, _utils.getMaxHeight)(contentHeight, offsetHeight);

      var nextScrollState = (0, _utils.getVerticalScrollValues)(scrollTop, maxHeight, partitions);

      this.setState(nextScrollState);
      onScroll(nextScrollState.verticalTransform);
    }
  }, {
    key: '_renderContents',
    value: function _renderContents() {
      var _this3 = this;

      var _props5 = this.props;
      var _props5$dynamicColumn = _props5.dynamicColumn;
      var dynamicColumn = _props5$dynamicColumn === undefined ? constants.columns.MIDDLE : _props5$dynamicColumn;
      var guttersConfig = _props5.guttersConfig;
      var _props5$horizontalScr = _props5.horizontalScrollConfig;
      _props5$horizontalScr = _props5$horizontalScr === undefined ? {} : _props5$horizontalScr;
      var _props5$horizontalScr2 = _props5$horizontalScr.passthroughOffsets;
      var passthroughOffsets = _props5$horizontalScr2 === undefined ? false : _props5$horizontalScr2;
      var _props5$verticalScrol = _props5.verticalScrollConfig;
      _props5$verticalScrol = _props5$verticalScrol === undefined ? {} : _props5$verticalScrol;
      var _props5$verticalScrol2 = _props5$verticalScrol.scrollbarWidth;
      var scrollbarWidth = _props5$verticalScrol2 === undefined ? constants.VERTICAL_SCROLLBAR_WIDTH : _props5$verticalScrol2;
      var _state6 = this.state;
      var displayBuffer = _state6.displayBuffer;
      var horizontalTransform = _state6.horizontalTransform;
      var partitions = _state6.partitions;
      var rows = _state6.rows;
      var shouldRender = _state6.shouldRender;
      var topPartitionIndex = _state6.topPartitionIndex;
      var verticalTransform = _state6.verticalTransform;


      var contentsStyle = shouldRender.verticalScrollbar ? {
        width: 'calc(100% - ' + scrollbarWidth + 'px)'
      } : undefined;

      var weightedPartitionIndex = topPartitionIndex * constants.OFFSET_BUFFER;
      var startingRowIndex = Math.min(weightedPartitionIndex, rows.length);
      var endingRowIndex = weightedPartitionIndex + displayBuffer;
      var weightedWidth = this._getWeightedWidth();

      var rowsWeWillRender = _lodash2.default.slice(rows, startingRowIndex, endingRowIndex);
      var partitionedRows = _lodash2.default.chunk(rowsWeWillRender, constants.OFFSET_BUFFER);
      var renderedPartitions = _lodash2.default.map(partitionedRows, function (row, outerIndex) {
        var partitionIndex = outerIndex + topPartitionIndex;
        var basePartitionOffset = partitions[partitionIndex];
        var partitionStyle = {
          transform: 'translate3d(-0px, ' + (basePartitionOffset - verticalTransform) + 'px, 0px)'
        };

        return _react2.default.createElement(
          'div',
          { className: 'rickscroll__partition', key: partitionIndex, style: partitionStyle },
          _lodash2.default.map(row, function (_ref7, innerIndex) {
            var className = _ref7.className;
            var contentComponent = _ref7.contentComponent;
            var contentClassName = _ref7.contentClassName;
            var gutters = _ref7.gutters;
            var height = _ref7.height;
            var isHeader = _ref7.isHeader;
            var key = _ref7.key;
            var rowProps = _ref7.props;
            return _react2.default.createElement(_Row2.default, {
              className: className,
              contentClassName: contentClassName,
              contentComponent: contentComponent,
              dynamicColumn: dynamicColumn,
              gutters: gutters,
              guttersConfig: guttersConfig,
              horizontalTransform: horizontalTransform,
              index: innerIndex,
              isHeader: isHeader,
              key: key || innerIndex,
              onStartResize: _this3._startResize,
              passthroughOffsets: passthroughOffsets,
              rowHeight: height,
              rowProps: rowProps,
              width: weightedWidth
            });
          })
        );
      });

      var _renderHeader2 = this._renderHeader();

      var bottomHeaderGutter = _renderHeader2.bottomHeaderGutter;
      var header = _renderHeader2.header;
      var topHeaderGutter = _renderHeader2.topHeaderGutter;

      // TODO remove partitions and shift the contents of the div

      return _react2.default.createElement(
        'div',
        { className: 'rickscroll__contents', key: 'contents', style: contentsStyle },
        header,
        topHeaderGutter,
        renderedPartitions,
        bottomHeaderGutter
      );
    }
  }, {
    key: '_renderCorner',
    value: function _renderCorner() {
      var _props6 = this.props;
      var horizontalScrollConfig = _props6.horizontalScrollConfig;
      var _props6$horizontalScr = _props6.horizontalScrollConfig;
      _props6$horizontalScr = _props6$horizontalScr === undefined ? {} : _props6$horizontalScr;
      var _props6$horizontalScr2 = _props6$horizontalScr.scrollbarHeight;
      var scrollbarHeight = _props6$horizontalScr2 === undefined ? constants.HORIZONTAL_SCROLLBAR_HEIGHT : _props6$horizontalScr2;
      var _props6$verticalScrol = _props6.verticalScrollConfig;
      _props6$verticalScrol = _props6$verticalScrol === undefined ? {} : _props6$verticalScrol;
      var _props6$verticalScrol2 = _props6$verticalScrol.scrollbarWidth;
      var scrollbarWidth = _props6$verticalScrol2 === undefined ? constants.VERTICAL_SCROLLBAR_WIDTH : _props6$verticalScrol2;
      var shouldRender = this.state.shouldRender;


      var shouldRenderCorner = !!horizontalScrollConfig && shouldRender.verticalScrollbar;

      if (!shouldRenderCorner) {
        return null;
      }

      var cornerStyle = {
        height: scrollbarHeight + 'px',
        width: scrollbarWidth + 'px'
      };

      return _react2.default.createElement('div', { className: 'rickscroll__corner', style: cornerStyle });
    }
  }, {
    key: '_renderHeader',
    value: function _renderHeader() {
      var _props7 = this.props;
      var _props7$dynamicColumn = _props7.dynamicColumn;
      var dynamicColumn = _props7$dynamicColumn === undefined ? constants.columns.MIDDLE : _props7$dynamicColumn;
      var guttersConfig = _props7.guttersConfig;
      var _props7$headerType = _props7.headerType;
      var headerType = _props7$headerType === undefined ? constants.headerType.DEFAULT : _props7$headerType;
      var height = _props7.height;
      var _props7$horizontalScr = _props7.horizontalScrollConfig;
      _props7$horizontalScr = _props7$horizontalScr === undefined ? {} : _props7$horizontalScr;
      var _props7$horizontalScr2 = _props7$horizontalScr.scrollbarHeight;
      var scrollbarHeight = _props7$horizontalScr2 === undefined ? constants.HORIZONTAL_SCROLLBAR_HEIGHT : _props7$horizontalScr2;
      var _state7 = this.state;
      var headers = _state7.headers;
      var rows = _state7.rows;
      var shouldRender = _state7.shouldRender;
      var verticalTransform = _state7.verticalTransform;


      if (!headers || headers.length === 0) {
        return {};
      }

      var maxLockPosition = headers[headers.length - 1].lockPosition;

      var findNextHeaderIndex = _lodash2.default.findIndex(headers, function (_ref8) {
        var lockPosition = _ref8.lockPosition;
        return lockPosition > verticalTransform;
      });
      var nextHeaderIndex = findNextHeaderIndex === -1 ? headers.length : findNextHeaderIndex;
      var weightedWidth = this._getWeightedWidth();

      if (headerType === constants.headerType.STACKING) {
        var _ret = function () {
          var topHeaderGutter = _react2.default.createElement(
            'div',
            { className: 'rickscroll__header-gutter rickscroll__header-gutter--top', key: 'top-header-gutter' },
            _lodash2.default.times(nextHeaderIndex, function (headerIndex) {
              var headerRowIndex = headers[headerIndex].index;
              var _rows$headerRowIndex = rows[headerRowIndex];
              var className = _rows$headerRowIndex.className;
              var contentComponent = _rows$headerRowIndex.contentComponent;
              var rowHeight = _rows$headerRowIndex.height;
              var key = _rows$headerRowIndex.key;
              var rowProps = _rows$headerRowIndex.props;


              return _react2.default.createElement(_Row2.default, {
                className: className,
                contentComponent: contentComponent,
                dynamicColumn: dynamicColumn,
                guttersConfig: guttersConfig,
                horizontalTransform: 0,
                index: headerRowIndex,
                key: key || headerIndex,
                rowHeight: rowHeight,
                rowProps: rowProps,
                width: weightedWidth
              });
            })
          );

          var bottomGutterStartIndex = nextHeaderIndex;
          /* We want to erase headers as they come into view in the contents view from the header gutter
           * We solve for the vertical transform that we need to remove a header from the bottom gutter:
           * height: height of the header we are transitioning
           * topHeight: height of all other gutters pinned to the top, not including baseHeight
           * realOffset: the verticalTransform that aligns the next header with the top of the rickscroll__contents
           * bottomHeight: the height of the bottom gutter of combined headers
           * adjustedBottomHeight: the total height of the headers in the bottom gutter with the baseHeight
           * adjustedTransform: the vertical transform that is adjusted to the scale of viewable contents
           * ------------------------------------------------------------------------------------------------------------
           * we should delete the top header from the bottom gutter if the adjusted transform is smaller than the
           * height of contents window
           */
          var contentsDivHeight = height - (shouldRender.horizontalScrollbar ? scrollbarHeight : 0);
          var baseHeight = headers[0].height;

          var _ref9 = headers[nextHeaderIndex] || headers[nextHeaderIndex - 1];

          var topHeight = _ref9.adjustHeaderOffset;
          var removeFirstHeaderOffset = _ref9.realOffset;
          var bottomHeight = headers[headers.length - 1].adjustHeaderOffset;

          var adjustedBottomHeight = baseHeight + bottomHeight - topHeight;
          var adjustedTransform = removeFirstHeaderOffset - verticalTransform + adjustedBottomHeight;
          if (bottomGutterStartIndex !== headers.length && adjustedTransform <= contentsDivHeight - 1) {
            bottomGutterStartIndex++;
            var skipHeadersUntil = (0, _lodash2.default)(headers).slice(bottomGutterStartIndex).findIndex(function (_ref10) {
              var adjustHeaderOffset = _ref10.adjustHeaderOffset;
              var realOffset = _ref10.realOffset;

              var restHeight = bottomHeight - adjustHeaderOffset;
              return realOffset + topHeight >= contentsDivHeight + verticalTransform - restHeight;
            });

            if (skipHeadersUntil >= 0) {
              bottomGutterStartIndex += skipHeadersUntil;
            } else {
              bottomGutterStartIndex = headers.length;
            }
          }

          var bottomHeaderGutter = _react2.default.createElement(
            'div',
            { className: 'rickscroll__header-gutter rickscroll__header-gutter--bottom', key: 'bottom-header-gutter' },
            (0, _lodash2.default)(headers).slice(bottomGutterStartIndex).map(function (_ref11, index) {
              var headerRowIndex = _ref11.index;
              var lockPosition = _ref11.lockPosition;

              var headerIndex = bottomGutterStartIndex + index;
              var _rows$headerRowIndex2 = rows[headerRowIndex];
              var className = _rows$headerRowIndex2.className;
              var contentComponent = _rows$headerRowIndex2.contentComponent;
              var rowHeight = _rows$headerRowIndex2.height;
              var key = _rows$headerRowIndex2.key;
              var rowProps = _rows$headerRowIndex2.props;


              return _react2.default.createElement(_Row2.default, {
                className: className,
                contentComponent: contentComponent,
                dynamicColumn: dynamicColumn,
                guttersConfig: guttersConfig,
                horizontalTransform: 0,
                index: headerRowIndex,
                key: key || headerIndex,
                rowHeight: rowHeight,
                rowProps: rowProps,
                width: weightedWidth
              });
            }).value()
          );

          return {
            v: { bottomHeaderGutter: bottomHeaderGutter, topHeaderGutter: topHeaderGutter }
          };
        }();

        if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
      } else if (headerType === constants.headerType.LOCKING) {
        var headerIndex = nextHeaderIndex - 1;

        var _ref12 = headers[nextHeaderIndex] || headers[headerIndex];

        var lockPosition = _ref12.lockPosition;
        var headerRowIndex = headers[headerIndex].index;
        var _rows$headerRowIndex3 = rows[headerRowIndex];
        var className = _rows$headerRowIndex3.className;
        var contentComponent = _rows$headerRowIndex3.contentComponent;
        var rowHeight = _rows$headerRowIndex3.height;
        var key = _rows$headerRowIndex3.key;
        var rowProps = _rows$headerRowIndex3.props;


        var headerStyle = {
          height: rowHeight + 'px',
          transform: 'translate3d(0px, 0px, 0px)'
        };

        if (verticalTransform < maxLockPosition && verticalTransform >= lockPosition - rowHeight) {
          var overlap = lockPosition - verticalTransform;
          var headerOffset = rowHeight - overlap;
          headerStyle.transform = 'translate3d(0px, -' + headerOffset + 'px, 0px)';
        }

        var header = _react2.default.createElement(
          'div',
          { className: 'rickscroll__header', key: 'header-' + headerRowIndex, style: headerStyle },
          _react2.default.createElement(_Row2.default, {
            className: className,
            contentComponent: contentComponent,
            dynamicColumn: dynamicColumn,
            guttersConfig: guttersConfig,
            horizontalTransform: 0,
            index: headerRowIndex,
            key: key || headerRowIndex,
            rowHeight: rowHeight,
            rowProps: rowProps,
            width: weightedWidth
          })
        );

        return { header: header };
      }

      return {};
    }

    /**
     * Decides whether or not to render the horizontal scroll bar
     * @return null or a container with horizontal scrollbar and maybe the corner piece
     */

  }, {
    key: '_renderHorizontalScrollbar',
    value: function _renderHorizontalScrollbar() {
      var _this4 = this;

      var _props8 = this.props;
      var _props8$dynamicColumn = _props8.dynamicColumn;
      var dynamicColumn = _props8$dynamicColumn === undefined ? constants.columns.MIDDLE : _props8$dynamicColumn;
      var guttersConfig = _props8.guttersConfig;
      var _props8$guttersConfig = _props8.guttersConfig;
      _props8$guttersConfig = _props8$guttersConfig === undefined ? {} : _props8$guttersConfig;
      var left = _props8$guttersConfig.left;
      var _props8$guttersConfig2 = _props8$guttersConfig.left;
      _props8$guttersConfig2 = _props8$guttersConfig2 === undefined ? {} : _props8$guttersConfig2;
      var _props8$guttersConfig3 = _props8$guttersConfig2.handleWidth;
      var leftHandleWidth = _props8$guttersConfig3 === undefined ? constants.LEFT_HANDLE_WIDTH : _props8$guttersConfig3;
      var leftHandlePosition = _props8$guttersConfig2.position;
      var right = _props8$guttersConfig.right;
      var _props8$guttersConfig4 = _props8$guttersConfig.right;
      _props8$guttersConfig4 = _props8$guttersConfig4 === undefined ? {} : _props8$guttersConfig4;
      var _props8$guttersConfig5 = _props8$guttersConfig4.handleWidth;
      var rightHandleWidth = _props8$guttersConfig5 === undefined ? constants.RIGHT_HANDLE_WIDTH : _props8$guttersConfig5;
      var rightHandlePosition = _props8$guttersConfig4.position;
      var horizontalScrollConfig = _props8.horizontalScrollConfig;
      var _props8$horizontalScr = _props8.horizontalScrollConfig;
      _props8$horizontalScr = _props8$horizontalScr === undefined ? {} : _props8$horizontalScr;
      var className = _props8$horizontalScr.className;
      var _props8$horizontalScr2 = _props8$horizontalScr.scaleWithCenterContent;
      var scaleWithCenterContent = _props8$horizontalScr2 === undefined ? false : _props8$horizontalScr2;
      var _props8$horizontalScr3 = _props8$horizontalScr.scrollbarHeight;
      var scrollbarHeight = _props8$horizontalScr3 === undefined ? constants.HORIZONTAL_SCROLLBAR_HEIGHT : _props8$horizontalScr3;
      var _props8$verticalScrol = _props8.verticalScrollConfig;
      _props8$verticalScrol = _props8$verticalScrol === undefined ? {} : _props8$verticalScrol;
      var _props8$verticalScrol2 = _props8$verticalScrol.scrollbarWidth;
      var scrollbarWidth = _props8$verticalScrol2 === undefined ? constants.VERTICAL_SCROLLBAR_WIDTH : _props8$verticalScrol2;
      var shouldRender = this.state.shouldRender;


      var withHorizontalScrolling = !!horizontalScrollConfig && shouldRender.horizontalScrollbar;

      if (!withHorizontalScrolling) {
        return null;
      }

      // TODO fix scaleWithCenterContent
      var contentWidth = this._getContentWidth();

      var _getGutterWidths = (0, _utils.getGutterWidths)({
        dynamicColumn: guttersConfig ? dynamicColumn : constants.columns.MIDDLE,
        leftHandlePosition: leftHandlePosition,
        leftHandleWidth: leftHandleWidth,
        rightHandlePosition: rightHandlePosition,
        rightHandleWidth: rightHandleWidth,
        width: this._getWeightedWidth()
      });

      var leftGutterWidth = _getGutterWidths.leftGutterWidth;
      var rightGutterWidth = _getGutterWidths.rightGutterWidth;

      var shouldRenderCorner = !!horizontalScrollConfig && shouldRender.verticalScrollbar;
      var cornerWidth = (0, _utils.returnWidthIfComponentExists)(scrollbarWidth, shouldRenderCorner);
      var adjustedContentWidth = contentWidth - cornerWidth;
      var leftWidth = void 0;
      var position = void 0;
      var scaledWidth = void 0;

      // If the scale with center content flag is enabled, we will adjust the scrollbar to be in the correct position
      // and set up the width to be equivelant to the center content
      // we will also have to adjust the size of the filler content by the gutters
      if (scaleWithCenterContent) {
        var rightWidth = (0, _utils.returnWidthIfComponentExists)(rightHandleWidth + rightGutterWidth, right);

        leftWidth = (0, _utils.returnWidthIfComponentExists)(leftHandleWidth + leftGutterWidth, left);
        adjustedContentWidth -= leftWidth + rightWidth;
        position = 'relative';
        scaledWidth = 'calc(100% - ' + leftWidth + 'px - ' + rightWidth + 'px - ' + cornerWidth + 'px)';
      }

      var wrapperStyle = {
        height: scrollbarHeight + 'px'
      };

      var scrollBarDivStyle = {
        height: scrollbarHeight + 'px',
        left: leftWidth,
        position: position,
        width: scaledWidth
      };

      var fillerStyle = { height: '1px', width: adjustedContentWidth + 'px' };

      var getHorizontalScrollbarRef = function getHorizontalScrollbarRef(r) {
        _this4._horizontalScrollbar = r;
      };
      var horizontalScrollbarClassName = (0, _classnames2.default)('rickscroll__horizontal-scrollbar', className);

      return _react2.default.createElement(
        'div',
        { className: 'rickscroll__bottom-wrapper', style: wrapperStyle },
        _react2.default.createElement(
          'div',
          {
            className: horizontalScrollbarClassName,
            key: 'scrollable',
            onScroll: this._onHorizontalScroll,
            ref: getHorizontalScrollbarRef,
            style: scrollBarDivStyle
          },
          _react2.default.createElement('div', { style: fillerStyle }),
          ' '
        ),
        this._renderCorner()
      );
    }

    /**
     * Decides whether or not to render the vertical scroll bar
     * @return null or a container with vertical scrollbar
     */

  }, {
    key: '_renderVerticalScrollbar',
    value: function _renderVerticalScrollbar() {
      var _this5 = this;

      var _props$verticalScroll3 = this.props.verticalScrollConfig;
      _props$verticalScroll3 = _props$verticalScroll3 === undefined ? {} : _props$verticalScroll3;
      var className = _props$verticalScroll3.className;
      var _props$verticalScroll4 = _props$verticalScroll3.scrollbarWidth;
      var scrollbarWidth = _props$verticalScroll4 === undefined ? constants.VERTICAL_SCROLLBAR_WIDTH : _props$verticalScroll4;
      var _state8 = this.state;
      var contentHeight = _state8.contentHeight;
      var shouldRender = _state8.shouldRender;


      if (!shouldRender.verticalScrollbar) {
        return null;
      }

      var fillerStyle = {
        height: contentHeight + 'px',
        width: '1px'
      };
      var verticalScrollbarStyle = {
        minWidth: scrollbarWidth + 'px'
      };

      var getVerticalScrollbarRef = function getVerticalScrollbarRef(r) {
        _this5._verticalScrollbar = r;
      };
      var verticalScrollbarCassName = (0, _classnames2.default)('rickscroll__vertical-scrollbar', className);
      return _react2.default.createElement(
        'div',
        {
          className: verticalScrollbarCassName,
          onScroll: this._onVerticalScroll,
          ref: getVerticalScrollbarRef,
          style: verticalScrollbarStyle
        },
        _react2.default.createElement('div', { style: fillerStyle }),
        ' '
      );
    }

    /**
     * Decides which scrollbars should be showing based off of the dimensions of the content and rickscroll container.
     * @return { horizontalScrollbar, verticalScrollbar } a pair of booleans that tell rickscroll whether or not to render
     *                                                    the horizontal and vertical scrollbars
     */

  }, {
    key: '_shouldRenderScrollbars',
    value: function _shouldRenderScrollbars(contentHeight, height, width) {
      var _props9 = this.props;
      var _props9$horizontalScr = _props9.horizontalScrollConfig;
      _props9$horizontalScr = _props9$horizontalScr === undefined ? {} : _props9$horizontalScr;
      var _props9$horizontalScr2 = _props9$horizontalScr.scrollbarHeight;
      var scrollbarHeight = _props9$horizontalScr2 === undefined ? constants.HORIZONTAL_SCROLLBAR_HEIGHT : _props9$horizontalScr2;
      var _props9$verticalScrol = _props9.verticalScrollConfig;
      _props9$verticalScrol = _props9$verticalScrol === undefined ? {} : _props9$verticalScrol;
      var _props9$verticalScrol2 = _props9$verticalScrol.scrollbarWidth;
      var scrollbarWidth = _props9$verticalScrol2 === undefined ? constants.VERTICAL_SCROLLBAR_WIDTH : _props9$verticalScrol2;


      var clientHeightTooSmall = height < contentHeight;
      var clientHeightTooSmallWithHorizontalScrollbar = height < contentHeight + scrollbarHeight;

      var contentWidth = this._getContentWidth();
      var clientWidthTooSmall = width < contentWidth;
      var clientWidthTooSmallWithVerticalScrollbar = width < contentWidth + scrollbarWidth;

      var shouldRenderVerticalScrollbar = clientHeightTooSmall || clientWidthTooSmall && clientHeightTooSmallWithHorizontalScrollbar;
      var shouldRenderHorizontalScrollbar = clientWidthTooSmall || clientHeightTooSmall && clientWidthTooSmallWithVerticalScrollbar;

      return {
        horizontalScrollbar: shouldRenderHorizontalScrollbar,
        verticalScrollbar: shouldRenderVerticalScrollbar
      };
    }
  }, {
    key: '_startResize',
    value: function _startResize(side) {
      var _this6 = this;

      return function (_ref13) {
        var clientX = _ref13.clientX;

        document.addEventListener('mouseup', _this6._stopResize, { capture: true });
        var _props$guttersConfig = _this6.props.guttersConfig;
        _props$guttersConfig = _props$guttersConfig === undefined ? {} : _props$guttersConfig;
        var basePosition = _props$guttersConfig[side].position;

        _this6.setState({
          resize: {
            basePosition: basePosition,
            performing: true,
            side: side,
            startingPosition: clientX
          }
        });
      };
    }
  }, {
    key: '_stopResize',
    value: function _stopResize() {
      document.removeEventListener('mouseup', this._stopResize, { capture: true });
      var side = this.state.resize.side;
      var _props$guttersConfig2 = this.props.guttersConfig;
      _props$guttersConfig2 = _props$guttersConfig2 === undefined ? {} : _props$guttersConfig2;
      var _props$guttersConfig3 = _props$guttersConfig2[side];
      _props$guttersConfig3 = _props$guttersConfig3 === undefined ? {} : _props$guttersConfig3;
      var _props$guttersConfig4 = _props$guttersConfig3.onResizeEnd;
      var onResizeEnd = _props$guttersConfig4 === undefined ? function () {} : _props$guttersConfig4;
      var position = _props$guttersConfig3.position;

      this.setState({
        resize: {
          basePosition: 0,
          performing: false,
          side: '',
          startingPosition: 0
        }
      });
      onResizeEnd(position);
    }

    // public

  }, {
    key: 'scrollTo',
    value: function scrollTo(_ref14) {
      var _ref14$x = _ref14.x;
      var x = _ref14$x === undefined ? 0 : _ref14$x;
      var _ref14$y = _ref14.y;
      var y = _ref14$y === undefined ? 0 : _ref14$y;
      var animation = this.state.animation;

      if (animation) {
        animation.stop();
      }

      var scrollingToPosition = new _models.Point(x, y);

      animation = new _animationTimer.AnimationTimer().on('tick', this._getThrottledAnimationFrameFn(scrollingToPosition)).play();

      this.setState({ animation: animation, scrollingToPosition: scrollingToPosition });
    }
  }, {
    key: 'scrollToHeader',
    value: function scrollToHeader(headerIndex) {
      var lists = this.props.lists;
      var headers = this.state.headers;


      if (!lists || headerIndex >= lists.length || headerIndex < 0) {
        return;
      }

      this.scrollTo({ y: headers[headerIndex].lockPosition });
    }
  }, {
    key: 'toggleSection',
    value: function toggleSection(sectionIndex) {
      var _props10 = this.props;
      var _props10$headerType = _props10.headerType;
      var headerType = _props10$headerType === undefined ? constants.headerType.DEFAULT : _props10$headerType;
      var lists = _props10.lists;
      var oldCollapsedSections = this.state.collapsedSections;

      var stackHeaders = headerType === constants.headerType.STACKING;

      if (!lists || sectionIndex >= lists.length || sectionIndex < 0) {
        return;
      }

      var collapsedState = !oldCollapsedSections[sectionIndex];
      oldCollapsedSections[sectionIndex] = collapsedState;

      var _buildRowConfig3 = (0, _utils.buildRowConfig)(lists, stackHeaders, oldCollapsedSections);

      var avgRowHeight = _buildRowConfig3.avgRowHeight;
      var collapsedSections = _buildRowConfig3.collapsedSections;
      var contentHeight = _buildRowConfig3.contentHeight;
      var headers = _buildRowConfig3.headers;
      var partitions = _buildRowConfig3.partitions;
      var rows = _buildRowConfig3.rows;

      this.setState({ avgRowHeight: avgRowHeight, collapsedSections: collapsedSections, contentHeight: contentHeight, headers: headers, partitions: partitions, rows: rows });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props11 = this.props;
      var className = _props11.className;
      var height = _props11.height;
      var horizontalScrollConfig = _props11.horizontalScrollConfig;
      var _props11$horizontalSc = _props11.horizontalScrollConfig;
      _props11$horizontalSc = _props11$horizontalSc === undefined ? {} : _props11$horizontalSc;
      var _props11$horizontalSc2 = _props11$horizontalSc.scrollbarHeight;
      var scrollbarHeight = _props11$horizontalSc2 === undefined ? constants.HORIZONTAL_SCROLLBAR_HEIGHT : _props11$horizontalSc2;
      var _props11$style = _props11.style;
      var style = _props11$style === undefined ? {} : _props11$style;
      var width = _props11.width;
      var _state9 = this.state;
      var performing = _state9.resize.performing;
      var shouldRender = _state9.shouldRender;


      var scrollableClassName = (0, _classnames2.default)('rickscroll', {
        'rickscroll--performing-resize': performing
      }, className);
      var topWrapperStyle = !!horizontalScrollConfig && shouldRender.horizontalScrollbar ? {
        height: 'calc(100% - ' + scrollbarHeight + 'px)'
      } : undefined;

      var rickscrollStyle = _extends({}, style, {
        height: height + 'px',
        width: width + 'px'
      });

      return _react2.default.createElement(
        'div',
        { className: scrollableClassName, style: rickscrollStyle },
        _react2.default.createElement(
          'div',
          {
            className: 'rickscroll__top-wrapper',
            key: 'top-wrapper',
            onMouseMove: this._onResize,
            onMouseUp: this._stopResize,
            onWheel: this._onMouseWheel,
            style: topWrapperStyle
          },
          this._renderContents(),
          this._renderVerticalScrollbar()
        ),
        this._renderHorizontalScrollbar()
      );
    }
  }]);

  return Scrollable;
}(_react2.default.Component);

exports.default = Scrollable;


Scrollable.propTypes = {
  className: _react.PropTypes.string,
  dynamicColumn: customTypes.column,
  guttersConfig: customTypes.guttersConfig,
  headerType: customTypes.headerType,
  height: _react.PropTypes.number.isRequired,
  horizontalScrollConfig: customTypes.horizontalScrollConfig,
  list: customTypes.list,
  lists: customTypes.lists,
  style: _react.PropTypes.object,
  verticalScrollConfig: customTypes.verticalScrollConfig,
  width: _react.PropTypes.number.isRequired
};